"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var mapLoop_1 = require("./mapLoop");
var createApiCaller_1 = require("./createApiCaller");
var defaults_1 = require("./defaults");
var createFilterReducer_1 = require("./createFilterReducer");
var mergeEntities_1 = require("./mergeEntities");
exports.initState = {
    entityCache: {},
    mounted: {},
    options: {}
};
exports.default = (function (_a) {
    var apiMap = _a.apiMap;
    var updateEntityCache = function (state, updates) {
        //console.log(updates);
        var newState = {};
        var updatedEntityNames = Object.keys(updates);
        for (var i = 0, l = updatedEntityNames.length; i < l; ++i) {
            var name_1 = updatedEntityNames[i];
            var oldSnapshotMap = state[name_1] || {};
            newState[name_1] = mergeEntities_1.default(oldSnapshotMap, updates[name_1]);
        }
        return __assign(__assign({}, state), newState);
    };
    // REDUCER
    return function (state, action) {
        if (state === void 0) { state = exports.initState; }
        if (action.type === "FILTER/IMPORT_ENTITIES") {
            return __assign(__assign({}, state), { entityCache: updateEntityCache(state.entityCache, action.entities) });
        }
        var filterName = action.filterName;
        if (action.type == "FILTER/MOUNT") {
            // merge options
            var options_1 = __assign({ searchApi: apiMap[filterName], initialQuery: undefined }, action.options);
            // initialize filter state
            var callApi = createApiCaller_1.default(filterName);
            var filterState = options_1.initialQuery ? (options_1.applyInitialQuery
                ? callApi(defaults_1.defaultFilterState, __assign(__assign({}, defaults_1.defaultSpecs), options_1.initialQuery), options_1)
                : __assign(__assign({}, defaults_1.defaultSpecs), options_1.initialQuery)) : defaults_1.defaultFilterState;
            // assemble global state
            return mapLoop_1.default(filterState, function (subState) {
                var _a, _b;
                return (__assign(__assign({}, state), { options: __assign(__assign({}, state.options), (_a = {}, _a[filterName] = options_1, _a)), mounted: __assign(__assign({}, state.mounted), (_b = {}, _b[filterName] = subState, _b)) }));
            });
        }
        else if (action.type == "FILTER/UNMOUNT") {
            var _a = state.options, _b = filterName, oldOptions = _a[_b], restOfOptions = __rest(_a, [typeof _b === "symbol" ? _b : _b + ""]);
            var _c = state.mounted, _d = filterName, oldFilterState = _c[_d], restOfMounted = __rest(_c, [typeof _d === "symbol" ? _d : _d + ""]);
            // assemble global state
            return __assign(__assign({}, state), { mounted: restOfMounted, options: restOfOptions });
        }
        // ignore filter action if there is no mounted filter
        var filterBefore = state.mounted[filterName];
        if (filterBefore === undefined)
            return state;
        // reduce filter
        var updateFilterState = createFilterReducer_1.default(state.options[filterName]);
        var filterAfter = updateFilterState(filterBefore, action);
        // update entity cache from success API response
        var entityCache = action.type == "FILTER/REQUEST_SUCCESS"
            ? updateEntityCache(state.entityCache, action.payload.entities)
            : state.entityCache;
        // assemble global state
        return mapLoop_1.default(filterAfter, function (subState) {
            var _a;
            return (__assign(__assign({}, state), { entityCache: entityCache, mounted: __assign(__assign({}, state.mounted), (_a = {}, _a[filterName] = subState, _a)) }));
        });
    };
});
