"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var redux_react_hook_1 = require("redux-react-hook");
var none = {};
var getSnapshots = function (stateSelector, entityName) {
    return function (state) {
        return stateSelector(state).entityCache[entityName];
    };
};
var createDenormalizer = function (snapshots) {
    return function (key) { return (snapshots || none)[key] || {}; };
};
exports.default = (function (stateSelector) {
    return function (entityName) {
        var snapshots = redux_react_hook_1.useMappedState(getSnapshots(stateSelector, entityName));
        return createDenormalizer(snapshots);
    };
});
